---
stages:
- build
- release

build-image:
  image: quay.io/podman/stable
  stage: build
  script:
  - podman build -t registry.gitlab.com/antoine.pilon/docker-wsl:${CI_COMMIT_SHA:0:8} . 
  - podman run registry.gitlab.com/antoine.pilon/docker-wsl:${CI_COMMIT_SHA:0:8}
  - podman export -o docker-wsl-${CI_COMMIT_SHA:0:8}.tar $(podman ps -a -q)
  artifacts:
    paths:
    - docker-wsl-${CI_COMMIT_SHA:0:8}.tar

build-release:
  stage: build
  image: quay.io/podman/stable
  only:
    refs:
    - main
    variables:
    - $RELEASE_VERSION =~ /^[1-9]*[0-9]\.[0-9]*[1-9]$/
  script:
  - podman build -t registry.gitlab.com/antoine.pilon/docker-wsl:${RELEASE_VERSION} . 
  - podman run registry.gitlab.com/antoine.pilon/docker-wsl:${RELEASE_VERSION}
  - podman export -o docker-wsl-${RELEASE_VERSION}.tar $(podman ps -a -q)
  - echo "JOB_ID=${CI_JOB_ID}" >> build.env
  artifacts:
    reports:
      dotenv: build.env
    paths:
    - docker-wsl-${RELEASE_VERSION}.tar

release:
  stage: release
  only:
    refs:
    - main
    variables:
    - $RELEASE_VERSION =~ /^[1-9]*[0-9]\.[0-9]*[1-9]$/
  before_script:
  # Clone the repository via HTTPS inside a new directory
  - git clone "https://${GITLAB_USERNAME}:${GITLAB_TOKEN}@${CI_SERVER_HOST}/${CI_PROJECT_PATH}.git" "${CI_COMMIT_SHA}"

  # Set the displayed user with the commits that are about to be made
  - git config --global user.email "${GIT_USER_EMAIL:-$GITLAB_USER_EMAIL}"
  - git config --global user.name "${GIT_USER_NAME:-$GITLAB_USER_NAME}"
  script:
  - cd "${CI_COMMIT_SHA}"
  - sed -ri "s#(/jobs/)[0-9]+(/artifacts/)#\1$JOB_ID\2#g" Readme.md
  - sed -ri "s#docker-wsl-[1-9]*[0-9]\.[0-9]*[1-9]\.tar#docker-wsl-$RELEASE_VERSION.tar#g" Readme.md
  after_script:
  # Go to the new directory
  - cd "${CI_COMMIT_SHA}"
  - git add .
  - git status
  - git commit -m "[${RELEASE_VERSION}] Release"
  - git push origin main -o ci.skip
